"use strict";

Liferay.Loader.define("content-dashboard-web$victory-vendor@36.7.0/lib-vendor/d3-interpolate/src/transform/index", ['module', 'exports', 'require', '../number', './parse'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.interpolateTransformSvg = exports.interpolateTransformCss = void 0;

    var _number = _interopRequireDefault(require("../number"));

    var _parse = require("./parse");

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function interpolateTransform(parse, pxComma, pxParen, degParen) {
      function pop(s) {
        return s.length ? s.pop() + " " : "";
      }

      function translate(xa, ya, xb, yb, s, q) {
        if (xa !== xb || ya !== yb) {
          var i = s.push("translate(", null, pxComma, null, pxParen);
          q.push({
            i: i - 4,
            x: (0, _number.default)(xa, xb)
          }, {
            i: i - 2,
            x: (0, _number.default)(ya, yb)
          });
        } else if (xb || yb) {
          s.push("translate(" + xb + pxComma + yb + pxParen);
        }
      }

      function rotate(a, b, s, q) {
        if (a !== b) {
          if (a - b > 180) b += 360;else if (b - a > 180) a += 360; // shortest path

          q.push({
            i: s.push(pop(s) + "rotate(", null, degParen) - 2,
            x: (0, _number.default)(a, b)
          });
        } else if (b) {
          s.push(pop(s) + "rotate(" + b + degParen);
        }
      }

      function skewX(a, b, s, q) {
        if (a !== b) {
          q.push({
            i: s.push(pop(s) + "skewX(", null, degParen) - 2,
            x: (0, _number.default)(a, b)
          });
        } else if (b) {
          s.push(pop(s) + "skewX(" + b + degParen);
        }
      }

      function scale(xa, ya, xb, yb, s, q) {
        if (xa !== xb || ya !== yb) {
          var i = s.push(pop(s) + "scale(", null, ",", null, ")");
          q.push({
            i: i - 4,
            x: (0, _number.default)(xa, xb)
          }, {
            i: i - 2,
            x: (0, _number.default)(ya, yb)
          });
        } else if (xb !== 1 || yb !== 1) {
          s.push(pop(s) + "scale(" + xb + "," + yb + ")");
        }
      }

      return function (a, b) {
        var s = [],

        // string constants and placeholders
        q = []; // number interpolators

        a = parse(a), b = parse(b);
        translate(a.translateX, a.translateY, b.translateX, b.translateY, s, q);
        rotate(a.rotate, b.rotate, s, q);
        skewX(a.skewX, b.skewX, s, q);
        scale(a.scaleX, a.scaleY, b.scaleX, b.scaleY, s, q);
        a = b = null; // gc

        return function (t) {
          var i = -1,
              n = q.length,
              o;

          while (++i < n) s[(o = q[i]).i] = o.x(t);

          return s.join("");
        };
      };
    }

    var interpolateTransformCss = interpolateTransform(_parse.parseCss, "px, ", "px)", "deg)");
    exports.interpolateTransformCss = interpolateTransformCss;
    var interpolateTransformSvg = interpolateTransform(_parse.parseSvg, ", ", ")", ")");
    exports.interpolateTransformSvg = interpolateTransformSvg;
  }
});
//# sourceMappingURL=index.js.map