"use strict";

Liferay.Loader.define("content-dashboard-web$victory-vendor@36.7.0/lib-vendor/d3-scale/src/diverging", ['module', 'exports', 'require', '../../../lib-vendor/d3-interpolate/src/index', './continuous', './init', './linear', './log', './sequential', './symlog', './pow'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = diverging;
    exports.divergingLog = divergingLog;
    exports.divergingPow = divergingPow;
    exports.divergingSqrt = divergingSqrt;
    exports.divergingSymlog = divergingSymlog;

    var _index = require("../../../lib-vendor/d3-interpolate/src/index");

    var _continuous = require("./continuous");

    var _init = require("./init");

    var _linear = require("./linear");

    var _log = require("./log");

    var _sequential = require("./sequential");

    var _symlog = require("./symlog");

    var _pow = require("./pow");

    function transformer() {
      var x0 = 0,
          x1 = 0.5,
          x2 = 1,
          s = 1,
          t0,
          t1,
          t2,
          k10,
          k21,
          interpolator = _continuous.identity,
          transform,
          clamp = false,
          unknown;

      function scale(x) {
        return isNaN(x = +x) ? unknown : (x = 0.5 + ((x = +transform(x)) - t1) * (s * x < s * t1 ? k10 : k21), interpolator(clamp ? Math.max(0, Math.min(1, x)) : x));
      }

      scale.domain = function (_) {
        return arguments.length ? ([x0, x1, x2] = _, t0 = transform(x0 = +x0), t1 = transform(x1 = +x1), t2 = transform(x2 = +x2), k10 = t0 === t1 ? 0 : 0.5 / (t1 - t0), k21 = t1 === t2 ? 0 : 0.5 / (t2 - t1), s = t1 < t0 ? -1 : 1, scale) : [x0, x1, x2];
      };

      scale.clamp = function (_) {
        return arguments.length ? (clamp = !!_, scale) : clamp;
      };

      scale.interpolator = function (_) {
        return arguments.length ? (interpolator = _, scale) : interpolator;
      };

      function range(interpolate) {
        return function (_) {
          var r0, r1, r2;
          return arguments.length ? ([r0, r1, r2] = _, interpolator = (0, _index.piecewise)(interpolate, [r0, r1, r2]), scale) : [interpolator(0), interpolator(0.5), interpolator(1)];
        };
      }

      scale.range = range(_index.interpolate);
      scale.rangeRound = range(_index.interpolateRound);

      scale.unknown = function (_) {
        return arguments.length ? (unknown = _, scale) : unknown;
      };

      return function (t) {
        transform = t, t0 = t(x0), t1 = t(x1), t2 = t(x2), k10 = t0 === t1 ? 0 : 0.5 / (t1 - t0), k21 = t1 === t2 ? 0 : 0.5 / (t2 - t1), s = t1 < t0 ? -1 : 1;
        return scale;
      };
    }

    function diverging() {
      var scale = (0, _linear.linearish)(transformer()(_continuous.identity));

      scale.copy = function () {
        return (0, _sequential.copy)(scale, diverging());
      };

      return _init.initInterpolator.apply(scale, arguments);
    }

    function divergingLog() {
      var scale = (0, _log.loggish)(transformer()).domain([0.1, 1, 10]);

      scale.copy = function () {
        return (0, _sequential.copy)(scale, divergingLog()).base(scale.base());
      };

      return _init.initInterpolator.apply(scale, arguments);
    }

    function divergingSymlog() {
      var scale = (0, _symlog.symlogish)(transformer());

      scale.copy = function () {
        return (0, _sequential.copy)(scale, divergingSymlog()).constant(scale.constant());
      };

      return _init.initInterpolator.apply(scale, arguments);
    }

    function divergingPow() {
      var scale = (0, _pow.powish)(transformer());

      scale.copy = function () {
        return (0, _sequential.copy)(scale, divergingPow()).exponent(scale.exponent());
      };

      return _init.initInterpolator.apply(scale, arguments);
    }

    function divergingSqrt() {
      return divergingPow.apply(null, arguments).exponent(0.5);
    }
  }
});
//# sourceMappingURL=diverging.js.map