"use strict";

Liferay.Loader.define("content-dashboard-web$victory-vendor@36.7.0/lib-vendor/d3-scale/src/quantile", ['module', 'exports', 'require', '../../../lib-vendor/d3-array/src/index', './init'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = quantile;

    var _index = require("../../../lib-vendor/d3-array/src/index");

    var _init = require("./init");

    function quantile() {
      var domain = [],
          range = [],
          thresholds = [],
          unknown;

      function rescale() {
        var i = 0,
            n = Math.max(1, range.length);
        thresholds = new Array(n - 1);

        while (++i < n) thresholds[i - 1] = (0, _index.quantileSorted)(domain, i / n);

        return scale;
      }

      function scale(x) {
        return x == null || isNaN(x = +x) ? unknown : range[(0, _index.bisect)(thresholds, x)];
      }

      scale.invertExtent = function (y) {
        var i = range.indexOf(y);
        return i < 0 ? [NaN, NaN] : [i > 0 ? thresholds[i - 1] : domain[0], i < thresholds.length ? thresholds[i] : domain[domain.length - 1]];
      };

      scale.domain = function (_) {
        if (!arguments.length) return domain.slice();
        domain = [];

        for (let d of _) if (d != null && !isNaN(d = +d)) domain.push(d);

        domain.sort(_index.ascending);
        return rescale();
      };

      scale.range = function (_) {
        return arguments.length ? (range = Array.from(_), rescale()) : range.slice();
      };

      scale.unknown = function (_) {
        return arguments.length ? (unknown = _, scale) : unknown;
      };

      scale.quantiles = function () {
        return thresholds.slice();
      };

      scale.copy = function () {
        return quantile().domain(domain).range(range).unknown(unknown);
      };

      return _init.initRange.apply(scale, arguments);
    }
  }
});
//# sourceMappingURL=quantile.js.map